unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ComCtrls, DB, ADODB, Grids, DBGrids;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button1: TButton;
    TreeView1: TTreeView;
    SpinEdit1: TSpinEdit;
    DataSource1: TDataSource;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
    MyTreeNode: TTreeNode;
    procedure QueryDetails(Parent_ID : Variant ; TreeNode : TTreeNode; Level : Integer);
    var
        Details : TADOQuery;
        MyTreeNode : TTreeNode;
    begin
      if Level < SpinEdit1.Value then
        begin
          Details := TADOQuery.Create(Self);
          Details.Connection := ADOConnection1;
          Details.Close;
          Details.SQL := ADOQuery1.SQL;
          if ((Parent_ID = NULL) or (Parent_ID = UnAssigned)) then
            Details.Parameters.ParamByName('p_parent_id').Value := -1
          else
            Details.Parameters.ParamByName('p_parent_id').Value := Parent_ID;
          Details.Open;
          while not Details.Eof do
            begin
              MyTreeNode := TreeView1.Items.AddChild(TreeNode,Details.FieldValues['dept_name']);
              QueryDetails(Details.FieldValues['dept_id'],MyTreeNode,Level + 1);
              Details.Next;
            end;
        end;
    end;

begin
  TreeView1.Items.Clear;
  ADOQuery1.Close;
  ADOQuery1.Parameters.ParamByName('p_parent_id').Value := -1;
  ADOQuery1.Open;
  while not ADOQuery1.Eof do
    begin
      MyTreeNode := TreeView1.Items.AddChild(NIL,ADOQuery1.FieldValues['dept_name']);
      QueryDetails(ADOQuery1.FieldValues['dept_id'],MyTreeNode,1);
      ADOQuery1.Next;
    end;
    TreeView1.Items.Item[0].Expand(True);
end;

end.
